#include "cpuID.h"

unsigned int cpufeatures = 0;  /* cpuFeatures will set this to the appropriate value
							      to be used by cpuCheckFeature, DONT MODIFY */

unsigned int cpuFeatures (void)
{
	unsigned int features;
	__asm
	{
		mov eax, 1			;set request type to a feature list from processor
		cpuid				;send request
		lea ebx, features	
		mov [ebx], edx		;save value
	}

	cpufeatures = features; 
	return features;
}

unsigned int cpuCheckFeature (unsigned int feature)
{
	if(!cpufeatures)	    /* cpuFeatures not called ? */
		return 0x10000001;

	if(cpufeatures&feature) /* feature exists, good- tell user */
		return feature;

	return 0;
}

char* cpuID (void)
{
	static char id[13];

	__asm
	{
		lea ebx, id
		mov cl, 0

CLEARID:
		inc cl
		mov dword ptr [ebx], 0
		cmp cl, 13
		jb CLEARID
	}

	__asm
	{
		xor eax, eax		;set request type to the string ID
		cpuid				;send request
		
		xchg eax, ebx		;swap so address register can be used
		lea ebx, id			;get destination string offset
							
		mov [ebx], eax		;save first four letters of string
		add ebx, 4			;go up anther four bytes			
							;repeat for next two registers
		mov [ebx], edx
		add ebx, 4

		mov [ebx], ecx
	}

	return id;				/* return pointer */
}